#define MY_INFINITY 0xffffff00

__kernel void initialize(
	unsigned int vertex_cnt,
	__global unsigned int * d_graph_property)
{
    unsigned int tid = get_global_id(0);
    
    if ( tid < vertex_cnt )
    {
        d_graph_property[tid] = MY_INFINITY;
    }
}

__kernel void kernel_step(
	__global unsigned int * vlist,
	__global unsigned int * elist,
	unsigned int vertex_cnt,
	__global uint * vplist,
	uint curr,
	__global int * changed) // 6
{
	unsigned int tid = get_global_id(0);
    
    if ( tid >= vertex_cnt ) return;

    if (vplist[tid]==curr)
    {
        uint start, end;
        start = vlist[tid];
        end = vlist[tid+1];
        #pragma irregular
        for (uint i=start; i<end; i++)
        {
            uint vid = elist[i];
            if (vplist[vid]==MY_INFINITY)
            {
                changed[0]=true;
                //*changed=true;
                vplist[vid]=curr+1;
            }
        }
    }
}
