#!/usr/bin/gnuplot
reset
set terminal postscript eps color enhanced font 'Times-New-Roman' 48

set tmargin 2
set bmargin 3.5
set lmargin 8
set rmargin 2

set size 2.2,1.2

set datafile separator ","

set output 'normalized_execution_time.eps'

set auto x
set yrange [0:4]
set xtics rotate by 20 right offset 2,0

set style fill solid border -1

set title  "Kernel execution time" offset 0,0
set ylabel "Normalized \n execution time" offset 2,0

#set key reverse Left outside right maxcols 1 maxrows 7 width -3 spacing 1 samplen 2 font 'Times-New-Roman, 42'
set nokey

set boxwidth 0.15
#num_of_categories=3
#set boxwidth 0.3/num_of_categories
#dx=0.5/num_of_categories
offset=-0.1

plot 1 title "CPU" linewidth 4 linecolor rgb "black" with lines, \
     './gpu_normalized.csv' using ($1+0.2):3                       title "GPU"            linecolor rgb "black" with boxes fillstyle pattern 4, \
     '' using ($1+0.2):7:8 with labels rotate by 30 offset -0.2,0.6 font "Times-New-Roman,38" notitle ,\
     './workgroup_normalized.csv' using ($1+0.4):3:xticlabels(2) title "WGP"            linecolor rgb "green"   with boxes, \
     '' using ($1+0.4):7:8 with labels rotate by 30 offset 0.8,0.6 font "Times-New-Roman,38" notitle ,\
     './oracle_normalized.csv' using ($1+0.6):($3+$4+$5)   title ""               linecolor rgb "white" with boxes, \
     './oracle_normalized.csv' using ($1+0.6):($3+$5)      title ""               linecolor rgb "light-gray"  with boxes, \
     './oracle_normalized.csv' using ($1+0.6):3            title "Oracle"         linecolor rgb "red" with boxes, \
     './on_the_fly_normalized.csv' using ($1+0.8):($3+$4+$5)       title "Profiling"      linecolor rgb "white" with boxes, \
     './on_the_fly_normalized.csv' using ($1+0.8):($3+$5)          title "Reshaping"      linecolor rgb "light-gray"  with boxes, \
     './on_the_fly_normalized.csv' using ($1+0.8):($3)             title "OnTheFly"       linecolor rgb "blue"  with boxes
