#define MY_INFINITY 0xffffff00

__kernel void initialize(
	unsigned int vertex_cnt,
	__global unsigned int * d_vpl)
{
    unsigned int tid = get_global_id(0);
    
    if ( tid < vertex_cnt )
    {
        d_vpl[tid] = MY_INFINITY;
    }
}

__kernel void kernel_step(
	__global unsigned int * vlist,
	__global unsigned int * elist,
	unsigned int vertex_cnt,
	__global uint * vplist,
	__global uint * randlist,
	uint color,
	__global uint * device_over)
{
	unsigned int tid = get_global_id(0);
    
    if ( tid >= vertex_cnt ) return;
    
    if (vplist[tid]==MY_INFINITY)
    {
        uint vid = tid;
        uint start, end;
        start = vlist[vid];
        end = vlist[vid+1];
        
        uint local_rand = randlist[vid];
        bool found_larger=false;
        #pragma irregular
        for (uint i=start; i<end; i++)
        {
            uint dest = elist[i];
            if (vplist[dest]<color) continue;
            if ( (randlist[dest]>local_rand) ||
                (randlist[dest]==local_rand && dest<vid))
            {
                found_larger = true;
                break;
            }
        }
        if (found_larger==false)
            vplist[vid] = color;
        else
            *device_over = false;
    }
}
