#!/usr/bin/env python

from os.path import exists
import os
import sys

import commands
import re

number_re = "+([0-9]+\.[01-9]+|[0-9]+)"

def get_num_kernel_runs(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)
        return len(val)
    except:
        return 0

def get_values(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)[0]
        return val
    except:
        return "-1.0"

def get_values_index(log, prefix, index):
    try:
        val = re.findall(prefix+number_re, log)[index]
        return val
    except:
        return "-1.0"

os.system("mkdir -p csv")

for i in range(3):
    if not exists("csv/cpu_run_"+str(i+1)+".csv"):
        csv_file = open("csv/cpu_run_"+str(i+1)+".csv", "w")
        csv_file.write("#graph,kernel_time_total,num_kernel_runs,kernel_time_each,\n")

        for graph in ["Watson_Gene","LDBC","Knowledge_Repo","fullchip","scale20","in-2004"]:
            output = commands.getoutput("LD_PRELOAD=$ARMCL_PATH/libArmCL.so METHOD=CPU NUM_CPU_CORES=4 ./GraphColoring-"+graph)

            csv_file.write(graph)

            total_elapsed_time = float(get_values(output, "total_elapsed_time: "))
            csv_file.write("," + str(total_elapsed_time))

            num_kernel_runs = int(get_num_kernel_runs(output, "kernel_elapsed_time: "))
            csv_file.write("," + str(num_kernel_runs))

            for j in range(num_kernel_runs):
                kernel_elapsed_time = float(get_values_index(output, "kernel_elapsed_time: ", j))
                csv_file.write("," + str(kernel_elapsed_time))

            csv_file.write("\n")
        csv_file.close()
