#!/usr/bin/env python

from os.path import exists
import os
import sys

import commands
import re

number_re = "+([0-9]+\.[01-9]+|[0-9]+)"

def get_num_kernel_runs(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)
        return len(val)
    except:
        return 0

def get_values(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)[0]
        return val
    except:
        return "-1.0"

def get_values_index(log, prefix, index):
    try:
        val = re.findall(prefix+number_re, log)[index]
        return val
    except:
        return "-1.0"

os.system("mkdir -p csv/on_the_fly/")

for i in range(3):
    for graph in ["Watson_Gene","LDBC","Knowledge_Repo","fullchip","scale20","in-2004"]:
        if not exists("./csv/on_the_fly/"+graph+"."+str(i+1)+".csv"):
            csv_file = open("./csv/on_the_fly/"+graph+"."+str(i+1)+".csv", "w")
            csv_file.write("#graph,kernel_time,profiler_overhead,reshaping_overhead,num_kernel_runs,kernel_time_each,\n")
            kernel_time = 0
            profiler_overhead = 0
            reshaping_overhead = 0
            num_kernel_runs = 0
            output = commands.getoutput("LD_PRELOAD=$ARMCL_PATH/libArmCL.so METHOD=OnTheFly NUM_CPU_CORES=4 ./GraphColoring-"+graph)

            csv_file.write(graph)

            num_kernel_runs = int(get_num_kernel_runs(output, "kernel_elapsed_time: "))
            for j in range(num_kernel_runs):
                kernel_time += float(get_values_index(output, "kernel_step kernel elapsed time: ", j))
                profiler_overhead += float(get_values_index(output, "kernel_step profiler_run prologue overhead: ", j))
                reshaping_overhead += float(get_values_index(output, "kernel_step threshold-based re-shaping prologue overhead: ", j))
            csv_file.write(","+str(kernel_time)+","+str(profiler_overhead)+","+str(reshaping_overhead)+","+str(num_kernel_runs))

            for j in range(num_kernel_runs):
                kernel_time_each = float(get_values_index(output, "kernel_step kernel elapsed time: ", j))
                profiler_overhead_each = float(get_values_index(output, "kernel_step profiler_run prologue overhead: ", j))
                reshaping_overhead_each = float(get_values_index(output, "kernel_step threshold-based re-shaping prologue overhead: ", j))
                csv_file.write(","+str(kernel_time_each)+","+str(profiler_overhead_each)+","+str(reshaping_overhead_each));
            csv_file.write("\n")
            csv_file.close()
