#!/usr/bin/env python

from os.path import exists
import os
import sys

import commands
import re

number_re = "+([0-9]+\.[01-9]+|[0-9]+)"

def get_num_kernel_runs(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)
        return len(val)
    except:
        return 0

def get_values(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)[0]
        return val
    except:
        return "-1.0"

def get_values_index(log, prefix, index):
    try:
        val = re.findall(prefix+number_re, log)[index]
        return val
    except:
        return "-1.0"

os.system("mkdir -p csv/oracle/")

for i in range(1):
    for graph in ["Watson_Gene","LDBC","Knowledge_Repo","fullchip","scale20","in-2004"]:
        for cpu_ratio in range(1, 100, 1):
            gpu_ratio = 100 - cpu_ratio
            if not exists("csv/oracle/"+graph+"."+str(cpu_ratio)+"."+str(gpu_ratio)+"."+str(i+1)):
                csv_file = open("csv/oracle/"+graph+"."+str(cpu_ratio)+"."+str(gpu_ratio)+"."+str(i+1), "w")
                csv_file.write("#profiler_overhead,sort_overhead,reshaping_overhead,kernel_time_total,num_kernel_runs,kernel_time_each,\n")

                output = commands.getoutput("LD_PRELOAD=$ARMCL_PATH/libArmCL.so METHOD=Oracle_Manual_Static NUM_CPU_CORES=4 CPU_RATIO=" + str(cpu_ratio) + " GPU_RATIO=" + str(gpu_ratio) + " ./GraphColoring-"+graph)

                profiler_overhead = float(get_values(output, "kernel_step profiler_run overhead: "))
                sort_overhead = float(get_values(output, "kernel_step sort-based re-shaping overhead: "))
                reshaping_overhead = float(get_values(output, "kernel_step threshold-based re-shaping overhead: "))

                num_kernel_runs = int(get_num_kernel_runs(output, "kernel_elapsed_time: "))
                kernel_time_each = []
                for j in range(num_kernel_runs):
                    kernel_time_each.append(float(get_values_index(output, "kernel_step kernel elapsed time: ", j)))

                kernel_time_total = 0
                for j in range(num_kernel_runs):
                    kernel_time_total += kernel_time_each[j]

                csv_file.write(str(profiler_overhead)+","+str(sort_overhead)+","+str(reshaping_overhead)+","+str(kernel_time_total)+","+str(num_kernel_runs))
                for j in range(num_kernel_runs):
                    csv_file.write("," + str(kernel_time_each[j]))

                csv_file.write("\n")
                csv_file.close()

