#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

// first index: total number of CPU cores of the system
// second index: the number of arguments for this kernel
unsigned long x86_kernel_params[40] = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
};

int num_total_cores = 4;
int num_total_params = 10;

// this interaction should be changed later
int num_proper_cpu_cores = 4;
int num_proper_gpu_cores = 64;

int PageRank_CPU_profiler(int* rowstr, float* p, int* colidx, float* q, int numPages,
        int* notify_size, size_t start_wg_id, size_t wg_size, size_t num_wgs)
{
    int sum_ = 0;
    for (size_t wg_id = start_wg_id; wg_id < start_wg_id + num_wgs; wg_id++) {
        size_t wi_id = wg_id * wg_size;

        for (size_t global_id = wi_id; global_id < wi_id + wg_size; global_id++) {
            int id = (int)global_id; // get_global_id(0);

            float DAM = 0.85;

            float newRank = 0.0;

            notify_size[id] = rowstr[id+1] - rowstr[id];
            sum_ += notify_size[id];

            ////#pragma irregular
            //for (int k = rowstr[id]; k < rowstr[id+1]; k++) {
            //    newRank += p[colidx[k]];
            //}

            //newRank = (1.0 - DAM) / numPages + DAM * newRank;

            //q[id] = newRank / numPages;
        }
    }
    return sum_;
}

extern "C" {
int CPU_thread_entry(int id) {
    int* rowstr = (int*)x86_kernel_params[num_total_params * id + 0];
    float* p = (float*)x86_kernel_params[num_total_params * id + 1];
    int* colidx = (int*)x86_kernel_params[num_total_params * id + 2];
    float* q = (float*)x86_kernel_params[num_total_params * id + 3];
    int* numPages = (int*)x86_kernel_params[num_total_params * id + 4];
    int* notify_size = (int*)x86_kernel_params[num_total_params * id + 5];
    size_t start_wg_id = (size_t)x86_kernel_params[num_total_params * id + 6];
    size_t wg_size = (size_t)x86_kernel_params[num_total_params * id + 7];
    size_t num_wgs = (size_t)x86_kernel_params[num_total_params * id + 8];

    //printf("[CPU thread] id: %d\n", id);

    int sum_ = PageRank_CPU_profiler(rowstr, p, colidx, q, *numPages,
            notify_size, start_wg_id, wg_size, num_wgs);

    int* has_finished = (int*)x86_kernel_params[num_total_params * id + 9];
    *has_finished = sum_;
    //printf("has_finished %d\n", *has_finished);

    return 0;
}
}
