#!/usr/bin/env python

from os.path import exists
import os
import sys

import commands
import re

number_re = "+([0-9]+\.[01-9]+|[0-9]+)"

def get_num_kernel_runs(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)
        return len(val)
    except:
        return 0

def get_values(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)[0]
        return val
    except:
        return "-1.0"

def get_values_index(log, prefix, index):
    try:
        val = re.findall(prefix+number_re, log)[index]
        return val
    except:
        return "-1.0"

os.system("mkdir -p csv")

for i in range(3):
    if not exists("csv/gpu_run_"+str(i+1)+".csv"):
        csv_file = open("csv/gpu_run_"+str(i+1)+".csv", "w")
        csv_file.write("#graph,kernel_time\n")

        for graph in ["Watson_Gene","LDBC","Knowledge_Repo","fullchip","scale20","in-2004"]:
            csv_file.write(graph)

            output = commands.getoutput("./PageRank-CSR-"+graph)

            kernel_elapsed_time = float(get_values(output, "kernel_elapsed_time: "))
            csv_file.write("," + str(kernel_elapsed_time) + "\n")
        csv_file.close()

