#!/usr/bin/env python

from os.path import exists
import os
import sys

import commands
import re

number_re = "+([0-9]+\.[01-9]+|[0-9]+)"

def get_values(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)[0]
        return val
    except:
        return "-1.0"

os.system("mkdir -p csv/on_the_fly/")

for i in range(3):
    for graph in ["Watson_Gene","LDBC","Knowledge_Repo","fullchip","scale20","in-2004"]:
        if not exists("csv/on_the_fly/"+graph+"."+str(i+1)+".csv"):
            csv_file = open("csv/on_the_fly/"+graph+"."+str(i+1)+".csv", "w")
            csv_file.write("#graph,kernel_time,profiler_run,reshaping\n")
            csv_file.write(graph)

            output = commands.getoutput("LD_PRELOAD=$ARMCL_PATH/libArmCL.so METHOD=OnTheFly NUM_CPU_CORES=4 ./PageRank-CSR-"+graph)
            kernel_time = float(get_values(output, "PageRank kernel elapsed time: "))
            profiler_run = float(get_values(output, "PageRank profiler_run prologue overhead: "))
            reshaping = float(get_values(output, "PageRank threshold-based re-shaping prologue overhead: "))

            print kernel_time
            print profiler_run
            print reshaping
            csv_file.write(","+str(kernel_time)+","+str(profiler_run)+","+str(reshaping)+"\n")
            csv_file.close()
