//------------------------------------------------------------------------------
// ARM OpenCL Runtime
//
// Copyright (c) Computer Systems and Platforms Laboratory
// http://csap.snu.ac.kr
// All right reserved.
//
// Author:
// Younghyun Cho <younghyun@csap.snu.ac.kr>
//

#include "ArmCLBuffer.h"

ArmCLBuffer::ArmCLBuffer(cl_mem buffer,
        cl_mem_flags flags,
        size_t size,
        void* host_ptr,
        cl_mem cpu_buffer,
        ArmCLContext* armcl_context)
    : buffer_(buffer), flags_(flags), size_(size), host_ptr_(host_ptr),
    cpu_buffer_(cpu_buffer), armcl_context_(armcl_context)
{
    context_ = armcl_context_->context();
    cpu_context_ = armcl_context->cpu_context();

    PrepareOpenCLCalls();
}

void ArmCLBuffer::PrepareOpenCLCalls()
{
    char* error;

    clCreateBuffer_p_ = (cl_mem (*) (cl_context context,
                cl_mem_flags flags,
                size_t size,
                void* host_ptr,
                cl_int* errcode_ret))dlsym(RTLD_NEXT, "clCreateBuffer");
    if ((error = dlerror()) != NULL) {
        fputs(error, stderr);
        exit(1);
    }
}
