//------------------------------------------------------------------------------
// ARM OpenCL Runtime
//
// Copyright (c) 2017 Computer Systems and Platforms Laboratory.
// All right reserved.
//
// Author:
// Younghyun Cho <younghyun@csap.snu.ac.kr>
//

#ifndef __ARM_OpenCL_H_
#define __ARM_OpenCL_H_

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <CL/cl.h>

#include <cstdio>
#include <cstdlib>
#include <iostream>

#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>

#include <arpa/inet.h>
#include <string.h>

#include <fcntl.h>
#include <dlfcn.h>

#include <map>
#include "ArmCLContext.h"
#include "ArmCLCommandQueue.h"
#include "ArmCLProgram.h"
#include "ArmCLBuffer.h"
#include "ArmCLKernel.h"

std::map<cl_context, ArmCLContext*> armcl_contexts;
std::map<cl_command_queue, ArmCLCommandQueue*> armcl_command_queues;
std::map<cl_program, ArmCLProgram*> armcl_programs;
std::map<cl_kernel, ArmCLKernel*> armcl_kernels;
std::map<cl_mem, ArmCLBuffer*> armcl_buffers;

ArmCLContext *context;

#endif
